#!/bin/bash
#
# Create Server Certificates
# 
# 
# This function will generate a Server cert
# IN: UNIQ_ID, SERIAL
#

# source this file to include the functions
. cfg/pki_funcs.sh

PARAM1=$1
PARAM2=$2
PARAM3=$3


usage() {
  echo
  echo "Generate a new Server certificate"
  echo
  echo
  echo "Generate a new certificate"
  echo "  usage:   gen_server.sh  <Org URL> <Serial #>"
  echo
  echo "  example: gen_server.sh  skunkworks.acme.xyz \\"
  echo "                          10052 \\"
  echo
  exit 1
}


main() {
  if [[ ! -f cfg/ca-i.crt.pem ]] || [[ ! -f cfg/ca-i.keys.pem ]]; then
    echo_block "ERROR: file cfg/ca-i.crt.pem cfg/ca-i.keys.pem is missing"
    usage
  fi
  if [[ ! -f cfg/SERIAL ]]; then
    echo_block "ERROR: file cfg/SERIAL is missing"
    usage
  fi

  if [[ -n $PARAM1 ]] && [[ -n $PARAM2 ]]; then
    UNIQ_ID="${PARAM2}.${PARAM1}"
    if [[ -f "distro/server_${UNIQ_ID}.p12" ]]; then
      echo_block "ERROR: certifate  <<distro/server_${UNIQ_ID}.p12>>  already exists"
      usage
    fi
    if [[ ! -f "cfg/${PARAM1}.cnf" ]]; then
      echo_block "ERROR: configuration file  <<cfg/${PARAM1}.cnf>>  is missing"
      usage
    fi

    gen_server $PARAM1 $PARAM2
  else
    usage
  fi
}

main
